<?php

/**
 * @file
 * Provides Drush commands to export contents in markdown format
 */


/**
 * Implements hook_drush_command().
 */
function markdown_exporter_drush_command()
{
    $commands = [];
    $commands['markdown-export'] = array(
    'description' => 'This is to export content in markdown format',
    'aliases' => ['mde'],
    'arguments' => array(
      'ctype' => 'Name of the content type to be exported'
    ),
    'drupal dependencies' => ['markdown_exporter'],
    'examples' => array(
       'drush mde' => 'Generates markdown files for node across all content types'
     ),
    );
    return $commands;
}

/**
 * Drush command logic.
 */
function drush_markdown_exporter_markdown_export()
{
  
  // to include the inc file with content_export_in_markdown() function
    module_load_include('inc', 'markdown_exporter', 'markdown_exporter');
  
    $args = func_get_args(); // argument supplied with drush command
    $content_types = array_keys(node_type_get_names());
    $exported_types = [];
    if (!empty($args)) {
        foreach ($args as $ntype) {
            if (in_array($ntype, $content_types)) {
                $exported_types[] = $ntype;
            }
        }
        if (empty($exported_types)) { // if none of the content types are valid
            drupal_set_message('Invalid argument supplied with the Drush command!');
            return;
        }
    } else {
        $exported_types = $content_types;
    }
    \Drupal::service('markdown_exporter.marekdown_generator')->bulkExport($exported_types, 'cli');
}
