<?php

namespace Drupal\markdown_exporter\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class MarkdownExporterController.
 *
 * @package Drupal\markdown_exporter\Controller
 */
class MarkdownExporterController extends ControllerBase {
  /**
   * Reload the previous page.
   */
  public function downloadFile() {
    $request = $this->requestStack->getCurrentRequest();
    $settings = \Drupal::config('markdown_exporter.settings');
    $md_dir = 'public://' . $settings->get('markdown_exporter_dir');
    $zip_file = $settings->get('markdown_exporter_dir', 'markdown_export') . '_' . REQUEST_TIME . '.zip';
    $zip_uri = 'temporary://' . $zip_file;

    $zip = new \ZipArchive();
    if ($handle = opendir($md_dir)) {
      $result = $zip->open(drupal_realpath($zip_uri), \ZipArchive::CREATE);
      if (!$result) {
        throw new DriverException('Zip archive could not be created. Error ' . $result);
      }

      while (false !== ($file_name = readdir($handle))) {
        if ($file_name != '.' && $file_name != '..') {
            $zip->addFile(drupal_realpath($md_dir).'/'.$file_name, $file_name);
        }
      }
      closedir($handle);
      $result = $zip->close();
      if (!$result) {
        throw new DriverException('Zip archive could not be closed.');
      }
    }
    $response = new Response();
    $response->headers->set('Content-Type', 'text/html; charset=utf-8');
    $response->header->set("Cache-Control: public");
    $response->header->set("Content-Type: application/zip");
    $response->header->set("Cache-Control: no-store, no-cache, must-revalidate");
    $response->header->set("Cache-Control: post-check=0, pre-check=0");
    $response->header->set("Content-Disposition: attachment; filename=\"$zip_file\";");
    $response->header->set("Content-Transfer-Encoding: binary");

    $fp = fopen(drupal_realpath($zip_uri), 'rb');
    fpassthru($fp);

    return $response;
  }
}